
_INIT_HC_SR04:

;hc_sr04.mbas,13 :: 		SUB PROCEDURE  INIT_HC_SR04()
;hc_sr04.mbas,14 :: 		duration_us = 0
	CLRF        _duration_us+0 
	CLRF        _duration_us+1 
;hc_sr04.mbas,15 :: 		distance_mm = 0
	CLRF        _distance_mm+0 
	CLRF        _distance_mm+1 
;hc_sr04.mbas,16 :: 		Trigger_HC_SR04 = 0
	BCF         Trigger_HC_SR04+0, BitPos(Trigger_HC_SR04+0) 
	RETURN      0
; end of _INIT_HC_SR04

_READ_HC_SR04:

;hc_sr04.mbas,19 :: 		SUB function READ_HC_SR04() as word
;hc_sr04.mbas,20 :: 		Trigger_HC_SR04 = 1              ' Trigger the module for 10usec
	BSF         Trigger_HC_SR04+0, BitPos(Trigger_HC_SR04+0) 
;hc_sr04.mbas,21 :: 		delay_us(10)
	MOVLW       6
	MOVWF       R13, 0
L__READ_HC_SR042:
	DECFSZ      R13, 1, 0
	BRA         L__READ_HC_SR042
	NOP
;hc_sr04.mbas,22 :: 		Trigger_HC_SR04 = 0
	BCF         Trigger_HC_SR04+0, BitPos(Trigger_HC_SR04+0) 
;hc_sr04.mbas,23 :: 		while Echo_HC_SR04 = 0           ' Waiting for the echo
L__READ_HC_SR044:
	BTFSC       Echo_HC_SR04+0, BitPos(Echo_HC_SR04+0) 
	GOTO        L__READ_HC_SR045
;hc_sr04.mbas,24 :: 		nop
	NOP
;hc_sr04.mbas,25 :: 		wend
	GOTO        L__READ_HC_SR044
L__READ_HC_SR045:
;hc_sr04.mbas,26 :: 		TMR1L    = 0                   ' Clear the TMR1L value
	CLRF        TMR1L+0 
;hc_sr04.mbas,27 :: 		TMR1H    = 0                   ' Clear the TMR1H value
	CLRF        TMR1H+0 
;hc_sr04.mbas,28 :: 		T1CON    = 0x01                ' Enable TMR1
	MOVLW       1
	MOVWF       T1CON+0 
;hc_sr04.mbas,29 :: 		while Echo_HC_SR04 = 1           ' While echo received, let the TMR1 count
L__READ_HC_SR049:
	BTFSS       Echo_HC_SR04+0, BitPos(Echo_HC_SR04+0) 
	GOTO        L__READ_HC_SR0410
;hc_sr04.mbas,30 :: 		nop
	NOP
;hc_sr04.mbas,31 :: 		wend
	GOTO        L__READ_HC_SR049
L__READ_HC_SR0410:
;hc_sr04.mbas,32 :: 		duration_us = TMR1H<<8 + TMR1L ' Retain TMR1 value = ON pulse
	MOVF        TMR1H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        TMR1L+0, 0 
	ADDWF       R0, 1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _duration_us+0 
	MOVF        R1, 0 
	MOVWF       _duration_us+1 
;hc_sr04.mbas,34 :: 		distance_mm = (duration_us * 0.087) 'cm
	CALL        _Word2Double+0, 0
	MOVLW       14
	MOVWF       R4 
	MOVLW       45
	MOVWF       R5 
	MOVLW       50
	MOVWF       R6 
	MOVLW       123
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	CALL        _Double2Word+0, 0
	MOVF        R0, 0 
	MOVWF       _distance_mm+0 
	MOVF        R1, 0 
	MOVWF       _distance_mm+1 
;hc_sr04.mbas,35 :: 		result = distance_mm
	MOVF        R0, 0 
	MOVWF       READ_HC_SR04_local_result+0 
	MOVF        R1, 0 
	MOVWF       READ_HC_SR04_local_result+1 
	MOVF        READ_HC_SR04_local_result+0, 0 
	MOVWF       R0 
	MOVF        READ_HC_SR04_local_result+1, 0 
	MOVWF       R1 
	RETURN      0
; end of _READ_HC_SR04
